import express from 'express';
import bodyParser from 'body-parser';
import fs from 'fs';
import authenticateJWT from './lib/authenticateJWT';

const app = express();

app.use(bodyParser.urlencoded({extended : true}));
app.use(bodyParser.json());

const routes = 'routes';

app.all('*', (req, res, next) => {
    console.log(`[${new Date().toLocaleString()}] ${req.method} ${req.url}`);
    next();
});

fs.readdirSync(routes).forEach((file: string) => {
    const route = require(`./${routes}/${file}`);
    app.use(`/${file.split('.')[0]}`, route.default);
});

app.get('/test', authenticateJWT, (req, res) => {
    //@ts-ignore
    res.json({ code: 200, message: `Authorization successful for user ${req.user.username}!` });
});

app.listen(3000, () => {
    console.log('Running on http://localhost:3000');
});