import { Request, Response, NextFunction } from 'express';
import jwt from 'jsonwebtoken';

const authenticateJWT = (req: Request, res: Response, next: NextFunction) => {
    const authHeader = req.headers.authorization;

    if (authHeader) {
        const token = authHeader.split(' ')[1];

        jwt.verify(token, process.env.ACCESS_TOKEN_SECRET ?? "", (err: any, user: any) => {
            if (err) {
                return res.status(403).json({ code: 403, error: 'Forbidden' })
            }

            //@ts-ignore
            req.user = user;
            next();
        });
    } else {
        res.status(401).json({ code: 401, error: 'Unauthorized' });
    }
}

export default authenticateJWT;