import { Router } from "express";
import authenticateJWT from "../lib/authenticateJWT";
import Database from "../db/database";

const router = Router();
const db = new Database();

router.get('/', authenticateJWT, async (req, res) => {
    // @ts-ignore
    const userDB = (await db.query('SELECT * FROM users WHERE userId = ?', [req.user.userId]))[0];

    return res.json({
        code: 200,
        user: {
            username: userDB.username,
            xp: userDB.xp,
            level: userDB.level,
            dateJoined: userDB.dateJoined
        }
    })
});

export default router;